<template>
  <div :class="$style.formInput">
    <the-mask
      :class="$style.field"
      :mask="mask"
      :masked="masked"
      :value="value"
      :readonly="readonly"
      :placeholder="placeholder"
      @input="handleInput"
    />
    <label :class="$style.label">{{ label }}</label>
  </div>
</template>

<script>
import Style from "./../FormInput/style.module.scss";

export default {
  name: "MeFormInputMask",
  model: {
    prop: "value",
    event: "input"
  },
  props: {
    label: {
      type: String,
      required: true
    },
    mask: {
      type: Array,
      required: true
    },
    masked: {
      type: Boolean,
      default: false
    },
    value: {
      type: [String, Number],
      default: "text"
    },
    placeholder: {
      type: String,
      default: " "
    },
    readonly: {
      type: Boolean,
      default: false
    },
    focusOnCreate: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    $style() {
      return Style;
    }
  },
  methods: {
    handleInput(ev) {
      this.$emit("input", ev);
    }
  },
  mounted() {
    this.focusOnCreate ? this.$el.querySelector("input").focus() : null;
  }
};
</script>